/***************************************************************************
                          icecc.h  -  description
                             -------------------
    begin                :   14 21:00:28 EEST 2002
    copyright            : (C) 2002 by Vadim A. Khohlov
    email                : xvadim@teko.kherson.ua
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ICECC_H
#define ICECC_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qstatusbar.h>

#include <qstring.h>

#include "tools.h"

class QMouseEvent;
class QToolCfg;

/**
  * This Class is the base class for application. It sets up the main
  * window and providing a menubar
  * and statusbar.
  */
class IceCCApp : public QMainWindow
{
  Q_OBJECT
  
  public:
    /** construtor */
    IceCCApp();
    /** destructor */
    ~IceCCApp();
    /** initMenuBar creates the menu_bar and inserts the menuitems */
    void initMenuBar();

    /** setup the statusbar */
    void initStatusBar();
  /** No descriptions */
  void setTools(QString tools[COUNTTOOLS]);
private:
    QPopupMenu *toolMenu;
    QPopupMenu *helpMenu;
    /**
     * A command lines for tolls.
     */
    QString toolsCmd[COUNTTOOLS];
    /**  */
    QToolCfg *toolCfg;
    /** Private directory with IceWM's configs.
     */
    QString icewmCfgDir;

private slots: // Private slots
  /** shows an about dlg*/
  void slotHelpAbout();
  /** No descriptions */
  void slotToolOptions();

private: // Private methods
  /** 
   * Loads a command lines for tools.
   */
  void loadOptions();
  /** No descriptions */
  void saveOptions();
public slots: // Public slots
  /**
   * Runs a tool with number numTool.
   */
  void runTool(int numTool);

};
#endif 

