/***************************************************************************
                          qtoolcfg.cpp  -  description
                             -------------------
    begin                : Tue Apr 16 2002
    copyright            : (C) 2002 by Vadim A. Khohlov
    email                : xvadim@teko.kherson.ua
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qlayout.h>
#include <qhbox.h>
#include <qpushbutton.h>
#include <qlistbox.h>
#include <qlineedit.h>
#include <qlabel.h>

#include "qtoolcfg.h"
#include "tools.h"
#include "icecc.h"

QToolCfg::QToolCfg(QWidget *parent, const char *name ):
QDialog(parent,name, true)
{
    setCaption(tr("Tools Configurator"));

    QVBoxLayout *topLayout = new QVBoxLayout(this, 0);
    CHECK_PTR(topLayout);

    lbTools = new QListBox(this);
    CHECK_PTR(lbTools);
    QLabel *lbT = new QLabel(lbTools, " &Tools:", this);
    CHECK_PTR(lbT);
    topLayout->addWidget(lbT);
    topLayout->addWidget(lbTools);
    for(int i = 0; i < COUNTTOOLS; i++)
        lbTools->insertItem(toolNames[i]);
    lbTools->setMinimumSize(lbTools->sizeHint());

    QHBox *hbCommand = new QHBox(this);
    CHECK_PTR(hbCommand);
    QLabel *lbCom = new QLabel(" C&ommand:", hbCommand);
    topLayout->addWidget(hbCommand);
    edCommand = new QLineEdit(hbCommand);
    CHECK_PTR(edCommand);
    CHECK_PTR(lbCom);
    lbCom->setBuddy(edCommand);
    QPushButton *pbSet = new QPushButton("&Set", hbCommand);
    CHECK_PTR(pbSet);

    /* Buttons' section */
    QHBox *hbButtons = new QHBox(this);
    CHECK_PTR(hbButtons);
    topLayout->addWidget(hbButtons);
    QPushButton *pbOk = new QPushButton("&Ok", hbButtons);
    QPushButton *pbCancel = new QPushButton("&Cancel", hbButtons);
    CHECK_PTR(pbOk);
    CHECK_PTR(pbCancel);

    connect(lbTools, SIGNAL(highlighted(int)), SLOT(slotToolHightLighted(int)));
    connect(pbOk,    SIGNAL(clicked()),        SLOT(slotOk()));
    connect(pbCancel, SIGNAL(clicked()),       SLOT(reject()));
    connect(pbSet,    SIGNAL(clicked()),       SLOT(slotSetTool()));

}/* constructor */

QToolCfg::~QToolCfg()
{
}/* destructor */

/** No descriptions */
void QToolCfg::slotToolHightLighted(int numTool)
{
    edCommand->setText(toolsCmd[numTool]);
}/* QToolCfg::slotToolHightLighted(int numTool) */

/** No descriptions */
void QToolCfg::setTools(QString tools[COUNTTOOLS])
{
    for(int i = 0; i < COUNTTOOLS; i++)
        toolsCmd[i] = tools[i];
}/* QToolCfg::setTools(QString tools[COUNTTOOLS]) */

/** No descriptions */
void QToolCfg::slotOk()
{
    ((IceCCApp*)parentWidget())->setTools(toolsCmd);
    accept();
}/* QToolCfg::slotOk() */

/** No descriptions */
void QToolCfg::slotSetTool()
{
    if(lbTools->currentItem() >=0 )
        toolsCmd[lbTools->currentItem()] = edCommand->text();
}/* QToolCfg::slotSetTool() */
